# coding: utf-8

"""
    HRA-API

    This API provides programmatic access to data registered to the Human Reference Atlas (HRA). See the [HuBMAP HRA Portal](https://humanatlas.io/) for details. 

    The version of the OpenAPI document: 0.11.0
    Contact: help@hubmapconsortium.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SpatialEntityCommon(BaseModel):
    """
    Properties available in all spatial entity objects.
    """ # noqa: E501
    entity_id: Optional[StrictStr] = Field(default=None, description="Identifier of the entity the spatial object represents.", alias="entityId")
    ccf_annotations: Optional[List[StrictStr]] = Field(default=None, description="Annotations attached to the entity.")
    representation_of: Optional[StrictStr] = Field(default=None, description="Identifier for the item the spatial object represents.")
    reference_organ: Optional[StrictStr] = Field(default=None, description="Identifier for the organ the spatial object represents.")
    sex: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["entityId", "ccf_annotations", "representation_of", "reference_organ", "sex"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SpatialEntityCommon from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SpatialEntityCommon from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "entityId": obj.get("entityId"),
            "ccf_annotations": obj.get("ccf_annotations"),
            "representation_of": obj.get("representation_of"),
            "reference_organ": obj.get("reference_organ"),
            "sex": obj.get("sex")
        })
        return _obj


